diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
index 7fe89a8da..9a03bee83 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
@@ -24,7 +24,7 @@ public class ChunkDecoratorDebug
                     int blockId = chunkBlockOffset + blockBlockOffset;
                     int meta = chunkMetaOffset + blockMetaOffset;
 
-                    if (blockId < 0 || blockId >= Blocks.blocksList.length || Blocks.blocksList[blockId] == null)
+                    if (blockId < 0 || blockId >= Blocks.blocksList.length || Blocks.blocksList[blockId] == null || blockId == Blocks.WIRE_REDSTONE.id()) // Redstone seems to crash debug worlds, they don't stay placed anyway so this is the most convient fix -Useless
                         continue;
 
                     chunk.setBlockIDWithMetadata(x, 0, z, blockId, meta);
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index b28652865..f21c4a808 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -34,6 +34,7 @@ public abstract class WorldType
     private final Weather defaultWeather;
     private final WindProvider windProvider;
     private final boolean hasCeiling;
+    private final boolean hasFloor;
     private final float[] brightnessRamp;
     private final SeasonConfig seasonConfig;
     private final int minY;
@@ -51,6 +52,7 @@ public abstract class WorldType
         this.defaultWeather = properties.defaultWeather == null ? Weathers.OVERWORLD_CLEAR : properties.defaultWeather;
         this.windProvider = properties.windProvider == null ? new WindProviderGeneric() : properties.windProvider;
         this.hasCeiling = properties.hasCeiling;
+        this.hasFloor = properties.hasFloor;
         this.brightnessRamp = properties.brightnessRamp;
         this.seasonConfig = properties.seasonConfig == null ? SeasonConfig.builder().withSingleSeason(Seasons.NULL).build() : properties.seasonConfig;
         this.minY = properties.minY;
@@ -99,6 +101,10 @@ public abstract class WorldType
         return hasCeiling;
     }
 
+    public boolean hasFloor() {
+        return hasFloor;
+    }
+
     public float[] getBrightnessRamp() {
         return brightnessRamp;
     }
@@ -314,6 +320,7 @@ public abstract class WorldType
         private Weather defaultWeather = null;
         private WindProvider windProvider = null;
         private boolean hasCeiling = false;
+        private boolean hasFloor = true;
         private float[] brightnessRamp = null;
         private SeasonConfig seasonConfig = null;
         private int minY = 0;
@@ -350,6 +357,11 @@ public abstract class WorldType
             return this;
         }
 
+        public @NotNull Properties withNoFloor() {
+            this.hasFloor = false;
+            return this;
+        }
+
         public @NotNull Properties brightnessRamp(float[] brightnessRamp) {
             this.brightnessRamp = brightnessRamp;
             return this;
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 539333335..930400073 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -42,6 +42,7 @@ public abstract class WorldTypes {
         new WorldTypeNetherSkyblock(
             WorldTypeNether.defaultProperties("worldType.nether.skyblock")
                 .bounds(0, 127, 0)
+                .withNoFloor()
                 .withTags(WorldTypeTags.NETHER, WorldTypeTags.HOT, WorldTypeTags.BREAKS_COMPASS, WorldTypeTags.BREAKS_TIMEPIECES)
         )
     );
@@ -49,6 +50,7 @@ public abstract class WorldTypes {
         "minecraft:drift.default",
         new WorldTypeDrift(
             WorldTypeDrift.defaultProperties("worldType.drift.default")
+                .withNoFloor()
                 .withTags(WorldTypeTags.DRIFT, WorldTypeTags.COLD, WorldTypeTags.BREAKS_COMPASS, WorldTypeTags.BREAKS_TIMEPIECES)
         )
     );
@@ -74,6 +76,7 @@ public abstract class WorldTypes {
             WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
                 .bounds(0, 255, 0)
                 .oceanBlocks()
+                .withNoFloor()
                 .withTags(WorldTypeTags.OVERWORLD)
         )
     );
@@ -190,6 +193,7 @@ public abstract class WorldTypes {
             WorldTypeOverworld.defaultProperties("worldType.overworld.skyblock")
                 .bounds(0, 127, 0)
                 .portalBounds(0, 255)
+                .withNoFloor()
                 .withTags(WorldTypeTags.OVERWORLD)
         )
     );
@@ -207,6 +211,7 @@ public abstract class WorldTypes {
             WorldType.Properties.of("worldType.empty")
                 .brightnessRamp(WorldTypeEmpty.createLightRamp())
                 .bounds(0, 255, 0)
+                .withNoFloor()
                 .allowRespawn()
         )
     );
@@ -216,6 +221,7 @@ public abstract class WorldTypes {
             WorldType.Properties.of("worldType.debug")
                 .brightnessRamp(WorldTypeDebug.createLightRamp())
                 .bounds(0, 255, 0)
+                .withNoFloor()
                 .allowRespawn()
         )
     );
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index c081905ca..beca41ac7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -53,14 +53,14 @@ public class WeatherStorm extends WeatherRain {
                     }
                 }
             }
-
-            if (world.canBlockBeRainedOn(targetX, targetY, targetZ)) {
+            if (maxWeight > Integer.MIN_VALUE) {
                 world.addWeatherEffect(new EntityLightning(world, targetX, targetY, targetZ));
             }
         }
     }
 
     private static int evalStrikeWeight(final @NotNull World world, final @NotNull Random random, final int orgX, final int orgZ, final int checkX, final int checkY, final int checkZ) {
+        if (!world.canBlockBeRainedOn(checkX, checkY, checkZ)) return Integer.MIN_VALUE;
         final @NotNull Material material = world.getBlockMaterial(checkX, checkY - 1, checkZ);
         int weight = random.nextInt(10);
         weight += checkY;
@@ -73,8 +73,8 @@ public class WeatherStorm extends WeatherRain {
 
         final int distX = (checkX - orgX);
         final int distZ = (checkZ - orgZ);
-        final double dist = Math.sqrt(distX * distX + distZ + distZ);
-        final int decayFactor = MathHelper.floor(Math.sqrt(dist) / 4);
+        final double dist = Math.sqrt(distX * distX + distZ * distZ);
+        final int decayFactor = MathHelper.floor(dist / 4);
         weight -= decayFactor;
 
         return weight;
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
index ca1dd8f0a..0a3bad62e 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
@@ -57,9 +57,9 @@ achievement.downTheDrain.desc=Use a mesh block underwater to siphon items.
 achievement.buildHoe=Time to Farm!
 achievement.buildHoe.desc=Use planks and sticks to make a hoe.
 achievement.makeBread=Bake Bread
-achievement.makeBread.desc=Turn wheat into bread.
+achievement.makeBread.desc=Bake dough into bread.
 achievement.bakeCake=The Lie
-achievement.bakeCake.desc=Wheat, sugar, milk and eggs!
+achievement.bakeCake.desc=Dough, sugar, milk and eggs!
 achievement.buildBetterPickaxe=Getting an Upgrade
 achievement.buildBetterPickaxe.desc=Construct a better pickaxe.
 achievement.cookFish=Delicious Fish
@@ -105,8 +105,8 @@ achievement.tripleHit.desc=Hit three mobs with a single golden arrow.
 
 achievement.enterNether=Hell Bent
 achievement.enterNether.desc=Enter the Nether.
-achievement.swimNether=Frozen Over
-achievement.swimNether.desc=Melt some ice and take a swim.
+achievement.swimNether=Hot Spring
+achievement.swimNether.desc=Take a "relaxing" swim in the Nether.
 achievement.enterWarrens=Hidden Depths
 achievement.enterWarrens.desc=Enter the Warrens.
 achievement.getNethercoal=Hot Stuff
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 0b36bb940..ca95a3382 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -390,6 +390,10 @@ class WorkbenchGenerator {
             .addInput(Blocks.SLATE)
             .create("slate_to_slate_layers", new ItemStack(Blocks.LAYER_SLATE, 8));
 
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.BLOCK_ASH)
+            .create("ash_to_ash_layers", new ItemStack(Blocks.LAYER_ASH, 8));
+
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.LEAVES_OAK)
             .create("oak_leaves_to_leaf_pile", new ItemStack(Blocks.LAYER_LEAVES_OAK, 8));
@@ -1259,8 +1263,24 @@ class WorkbenchGenerator {
         RecipeBuilderShaped plate = RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("##");
 
         plate.addInput('#', Blocks.STONE).create("stone_pressure_plate", Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
+        plate.addInput('#', Blocks.BASALT).create("basalt_pressure_plate", Blocks.PRESSURE_PLATE_BASALT.getDefaultStack());
+        plate.addInput('#', Blocks.LIMESTONE).create("limestone_pressure_plate", Blocks.PRESSURE_PLATE_LIMESTONE.getDefaultStack());
+        plate.addInput('#', Blocks.GRANITE).create("granite_pressure_plate", Blocks.PRESSURE_PLATE_GRANITE.getDefaultStack());
+        plate.addInput('#', Blocks.PERMAFROST).create("permafrost_pressure_plate", Blocks.PRESSURE_PLATE_PERMAFROST.getDefaultStack());
+        plate.addInput('#', Blocks.NETHERRACK).create("netherrack_pressure_plate", Blocks.PRESSURE_PLATE_NETHERRACK.getDefaultStack());
+        plate.addInput('#', Blocks.GLOOMSTONE).create("gloomstone_pressure_plate", Blocks.PRESSURE_PLATE_GLOOMSTONE.getDefaultStack());
+        plate.addInput('#', Blocks.SANDSTONE).create("sandstone_pressure_plate", Blocks.PRESSURE_PLATE_SANDSTONE.getDefaultStack());
+        plate.addInput('#', Blocks.BRIMSTONE).create("brimstone_pressure_plate", Blocks.PRESSURE_PLATE_BRIMSTONE.getDefaultStack());
+
+        plate.addInput('#', Blocks.COBBLE_STONE).create("cobble_stone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_BASALT).create("cobble_basalt_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_BASALT.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_LIMESTONE).create("cobble_limestone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_LIMESTONE.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_GRANITE).create("cobble_granite_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_GRANITE.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_PERMAFROST).create("cobble_permafrost_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_PERMAFROST.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_NETHERRACK).create("cobble_netherrack_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_NETHERRACK.getDefaultStack());
+        plate.addInput('#', Blocks.COBBLE_GLOOMSTONE).create("cobble_gloomstone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_GLOOMSTONE.getDefaultStack());
+
         plate.addInput('#', Blocks.PLANKS_OAK).create("wooden_pressure_plate", Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
-        plate.addInput('#', "minecraft:cobblestones").create("cobblestone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
         for (DyeColor color : DyeColor.values()) {
             plate.addInput('#', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID +  "_wooden_pressure_plate", new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
         }
